/*
    ---------------------------------------------------------------------- copyright and license ---

    file: src/switcher.cpp

    Copyright © 2014, 2016 Van de Bugger.

    This file is a part of Tapper.

    Tapper is free software: you can redistribute it and/or modify it under the terms of the GNU
    General Public License as published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    Tapper is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
    even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License along with Tapper.  If not,
    see <http://www.gnu.org/licenses/>.

    ---------------------------------------------------------------------- copyright and license ---
*/


#include "switcher.hpp"


#include <cassert>


// -------------------------------------------------------------------------------------------------
// layout_switcher_t
// -------------------------------------------------------------------------------------------------


layout_switcher_t::layout_switcher_t(
    x::kb_t &       kb,
    map_t const &   map,
    bool            bell
) :
    tapper_t( kb ),
    _map( map ),
    _bell( bell )
{
}; // ctor


void
layout_switcher_t::on_tap(
    KeyCode key_code
) {
    map_t::const_iterator it = _map.find( key_code );
    if ( it != _map.end() ) {
        _kb.lock_group( it->second );
        if ( _bell ) {
            _kb.bell();
        }; // if
        _kb.display().flush();
    }; // if
}; // on_tap


// end of file //
