/*
    ---------------------------------------------------------------------- copyright and license ---

    file: src/switcher.hpp

    Copyright © 2014, 2016 Van de Bugger.

    This file is a part of Tapper.

    Tapper is free software: you can redistribute it and/or modify it under the terms of the GNU
    General Public License as published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    Tapper is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
    even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License along with Tapper.  If not,
    see <http://www.gnu.org/licenses/>.

    ---------------------------------------------------------------------- copyright and license ---
*/


#ifndef _SWITCHER_HPP_
#define _SWITCHER_HPP_


#include "config.h"
#include "base.hpp"
#include "tapper.hpp"
#include "x.hpp"

#include <map>
#include <vector>


// -------------------------------------------------------------------------------------------------
// layout_switcher_t
// -------------------------------------------------------------------------------------------------


class layout_switcher_t : public tapper_t {

    public :

        typedef std::map< KeyCode, int >    map_t;

        layout_switcher_t( x::kb_t & kb, map_t const & map, bool bell = false );

    protected :

        virtual void on_tap( KeyCode key_code );

    private :

        map_t               _map;
        bool                _bell;

}; // class layout_switcher_t


#endif // _SWITCHER_HPP_

// end of file //
